// VCView.cpp : CVCView NX̓̒`s܂B
//

#include "stdafx.h"
#include "VC.h"

#include "VCDoc.h"
#include "VCView.h"
#include "zipcvip/VipCommunicate.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVCView

IMPLEMENT_DYNCREATE(CVCView, CFormView)

BEGIN_MESSAGE_MAP(CVCView, CFormView)
	//{{AFX_MSG_MAP(CVCView)
	ON_BN_CLICKED(IDC_BTN_SEND, OnBtnSend)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCView NX̍\z/

CVCView::CVCView()
	: CFormView(CVCView::IDD)
{
	//{{AFX_DATA_INIT(CVCView)
	m_bSend = 0;
	m_strRecv = _T("");
	//}}AFX_DATA_INIT
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB

}

CVCView::~CVCView()
{
}

void CVCView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCView)
	DDX_Text(pDX, IDC_EDT_SEND, m_bSend);
	DDV_MinMaxByte(pDX, m_bSend, 0, 255);
	DDX_Text(pDX, IDC_STC_RECV, m_strRecv);
	//}}AFX_DATA_MAP
}

BOOL CVCView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CFormView::PreCreateWindow(cs);
}

void CVCView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	((CStatic*)GetDlgItem(IDC_STC_RECV))->SetWindowText(_T("0"));
}

/////////////////////////////////////////////////////////////////////////////
// CVCView NẌ

BOOL CVCView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void CVCView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CVCView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

void CVCView::OnPrint(CDC* pDC, CPrintInfo* /*pInfo*/)
{
	// TODO: p̃R[hɒǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// CVCView NX̐ff

#ifdef _DEBUG
void CVCView::AssertValid() const
{
	CFormView::AssertValid();
}

void CVCView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CVCDoc* CVCView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CVCDoc)));
	return (CVCDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CVCView NX̃bZ[W nh

int CVCView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFormView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ

	// ZIPCƐڑ
	char exename[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	GetModuleFileName( AfxGetInstanceHandle(), exename, _MAX_PATH-1 );
	_splitpath( exename, drive, dir, NULL, NULL );

	VIP_LoadPnlIF( CString( drive ) + CString( dir ) + CString("ZVipPnl.DLL") );
	VIP_PnlConnect( _T(""), GetSafeHwnd() );

	return 0;
}

void CVCView::OnDestroy() 
{
	CFormView::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ

	// ZIPCƐؒf
	VIP_PnlCut( _T(""), GetSafeHwnd() );
	VIP_FreePnlIF();
	
}

LRESULT CVCView::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	LRESULT	lRet;

	//	VIPp̒ʐMbZ[WeH
	if( message == VIP_GetWindowMessageID() ) {
		//	VIPpWindowbZ[W͏s
		lRet = VIP_PnlMessageProc( wParam, lParam );
		//	XV񂪎擾Ă邩H
		if( VIP_IsUpdateData() != FALSE ) {
			//	View̍XVs
			UpdateViewData();
		}
		//	ZbgʒmsꂽH
		else if( VIP_IsReset() != FALSE ) {
			// Zbg̏s
		}
		else{
			// none
		}
	}
	else {
		lRet = CFormView::WindowProc(message, wParam, lParam);
	}

	return	lRet;	
}

void CVCView::UpdateViewData()
{
	// _CAO擾
	UpdateData(TRUE);

	switch( VIP_GetUpdateMode() ){
		case ZIPCVIP_DATA_PIO:				  // o̓f[^̑|[g
			if( VIP_GetUpdateIndex() == 0 ){
				m_strRecv.Format( "%d", *(char*)VIP_GetUpdateData() );
			}
			else {
				// none
			}
			break;

		default:
			// none
			break;
	}

	// _CAOXV
	UpdateData(FALSE);

	return;
}

void CVCView::OnBtnSend() 
{
	// _CAO擾
	UpdateData(TRUE);

	BYTE data = m_bSend;
	VIP_SetPortData( 0, &data, sizeof(data) );

	// _CAOXV
	UpdateData(FALSE);
}
